# -*- coding: utf-8 -*-                                                                                  
#                                                                                     
#   _|        _|  _|            _|          _|_|            _|        _|  _|_|_|_|_|  
#   _|_|_|    _|        _|_|_|  _|  _|    _|        _|_|    _|    _|_|_|          _|  
#   _|    _|  _|  _|  _|        _|_|    _|_|_|_|  _|_|_|_|  _|  _|    _|        _|    
#   _|    _|  _|  _|  _|        _|  _|    _|      _|        _|  _|    _|      _|      
#   _|_|_|    _|  _|    _|_|_|  _|    _|  _|        _|_|_|  _|    _|_|_|    _|        
#   
#   Copyright:      2016 blickfeld7.com
#   Script name:    Repair esri-grid ASCII file line breaks
#   Created:	    18 Januar 2016
#   Author:         Florian Frank (blickfeld7.com)
#   Usage:          This script scans any Textfile in esri-grid file format and repairs 
#                   any possibly wrong line break. Change the path below and hit run ;-)
#   History:     	-
#                   -

# <<<< EINSTELLUNGEN >>>>
pfad = "C:\Users\johndoe\Desktop\IL_DGM10.asc"
#The Path should be within the user directory on your system

# ALLOWED CHARACTERS FOR NUMBERS
allowed = range(48, 58)	# '0-9'
allowed.append(45)		# '+'
allowed.append(46)		# '.'
allowed.append(44)		# ','
def stepRange(start, end, step):
    while start <= end:
        yield start
        start += step

from os.path import isfile
import re

# CHECK FILE
if(isfile(pfad) != True):
    raise IOError("File \""+pfad+"\" is not existing.")

# OPEN FILE
try:
	print "1/7 File \""+pfad+"\" is being processed..."
	lines = [line.rstrip('\n').rstrip('\r').replace('  ',' ') for line in open(pfad)]
except:
	raise IOError("File "+pfad+" couldn't be read.")

if(len(lines) < 1):
	raise ValueError("File has no line breaks.")

print "2/7 "+str(len(lines)+1)+" lines have been read."

# PARSE 	H E A D E R S
dataStart = cols = 0
for line in lines:
	if(re.search('^\w', line)):
		if(re.search('ncols ', line, re.IGNORECASE)):
			cols = int(line[6:])

		#print "Line("+str(len(line))+") :"+line
		dataStart += 1
	else:
		break

# CHECK 	D A T A
if(cols > 0 and dataStart > 0):
	print "3/7 Headers parsed successfully: nCols = "+str(cols)+", dataStart = line nr."+str(dataStart)
else:
	raise ValueError("On parsing headers. At least of the following parameters is 0:"+
			"nCols = "+str(cols)+
			"dataStart = "+str(dataStart))

# REORGANIZE 	L I N E S
print "4/7 Creating buffer of data without line breaks."
headers = chr(10).join(lines[0:dataStart])
data = chr(32).join(lines[dataStart:])
data = data.replace('  ', ' ')
print "5/7 Reorganizing buffer and separate each height value."
data = data.split(chr(32))

print "6/7 Group "+str(cols)+" values into one line."
newData = []

for i in stepRange(0, len(data), cols):
	newData.append(' '.join(data[i:i+cols]))
	#print str(i)

# WRITE 	C L E A N 	F I L E
try:
	name = pfad[0:pfad.rindex('.')]
	ext = pfad[pfad.rindex('.'):]
	cleanFilename = name+"_BF7"+ext
	clean = open(cleanFilename, 'w+')
except:
	print "ERROR: The file \""+name+"_BF7"+ext+"\" couldn't be created. No access rights to that directory?"

clean.write(headers)
clean.write(chr(10))
clean.write(chr(10).join(newData))
print "DONE: \""+cleanFilename+"\" successfully created."
#print chr(10).join(newData)